<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author    Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category  i-Educar
 * @license   @@license@@
 * @package   Core_Controller
 * @since     Arquivo disponvel desde a verso 1.1.0
 * @version   $Id$
 */

require_once 'CoreExt/Controller/Page/Interface.php';

/**
 * Core_Controller_Page_Interface interface.
 *
 * @author    Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category  i-Educar
 * @license   @@license@@
 * @package   Core_Controller
 * @since     Interface disponvel desde a verso 1.1.0
 * @version   @@package_version@@
 */
interface Core_Controller_Page_Interface extends CoreExt_Controller_Page_Interface
{
  /**
   * Setter.
   * @param CoreExt_DataMapper|string
   * @return Core_Controller_Page_Interface Prov interface fluda
   */
  public function setDataMapper($dataMapper);

  /**
   * Retorna uma instncia CoreExt_DataMapper.
   * @return CoreExt_DataMapper
   */
  public function getDataMapper();

  /**
   * Setter.
   * @return Core_Controller_Page_Interface Prov interface fluda
   */
  public function setBaseTitulo($titulo);

  /**
   * Retorna uma string para o ttulo da pgina.
   * @return string
   */
  public function getBaseTitulo();

  /**
   * Setter.
   * @param int $processoAp
   * @return Core_Controller_Page_Interface Prov interface fluda
   */
  public function setBaseProcessoAp($processoAp);

  /**
   * Retorna o cdigo de processo para autorizao de acesso ao usurio.
   * @return int
   */
  public function getBaseProcessoAp();
}