<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Avaliacao
 * @subpackage  UnitTests
 * @since       Arquivo disponvel desde a verso 1.1.0
 * @version     $Id$
 */

require_once 'Avaliacao/_tests/Service/TestCommon.php';
require_once 'Avaliacao/Model/NotaComponente.php';

/**
 * Avaliacao_Service_NotaAlunoTest class.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Avaliacao
 * @subpackage  UnitTests
 * @since       Classe disponvel desde a verso 1.1.0
 * @version     @@package_version@@
 */
class Avaliacao_Service_NotaAlunoTest extends Avaliacao_Service_TestCommon
{
  public function testCriaNovaInstanciaDeNotaAluno()
  {
    $notaAluno = $this->_getConfigOption('notaAluno', 'instance');
    $notaSave  = clone $notaAluno;
    $notaSave->id = NULL;

    // Configura mock para Avaliacao_Model_NotaAlunoDataMapper
    $mock = $this->getCleanMock('Avaliacao_Model_NotaAlunoDataMapper');
    $mock->expects($this->at(0))
         ->method('findAll')
         ->with(array(), array('matricula' => $this->_getConfigOption('matricula', 'cod_matricula')))
         ->will($this->returnValue(array()));

    $mock->expects($this->at(1))
         ->method('save')
         ->with($notaSave)
         ->will($this->returnValue(TRUE));

    $mock->expects($this->at(2))
         ->method('findAll')
         ->with(array(), array('matricula' => $this->_getConfigOption('matricula', 'cod_matricula')))
         ->will($this->returnValue(array($notaAluno)));

    $this->_setNotaAlunoDataMapperMock($mock);

    $service = $this->_getServiceInstance();
  }
}