<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Educacenso
 * @subpackage  Modules
 * @since       Arquivo disponvel desde a verso 1.2.0
 * @version     $Id$
 */

require_once 'Educacenso/Model/Aluno.php';
require_once 'Educacenso/Model/CodigoReferenciaDataMapper.php';

/**
 * Educacenso_Model_AlunoDataMapper class.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Educacenso
 * @subpackage  Modules
 * @since       Classe disponvel desde a verso 1.2.0
 * @version     @@package_version@@
 */
class Educacenso_Model_AlunoDataMapper extends Educacenso_Model_CodigoReferenciaDataMapper
{
  protected $_entityClass = 'Educacenso_Model_Aluno';
  protected $_tableName   = 'educacenso_cod_aluno';

  protected $_attributeMap = array(
    'aluno'      => 'cod_aluno',
    'alunoInep'  => 'cod_aluno_inep',
    'nomeInep'   => 'nome_inep',
    'fonte'      => 'fonte',
    'created_at' => 'created_at',
    'updated_at' => 'updated_at'
  );

  // aparentemente o campo alunoInep no deveria fazer parte da chave primaria, pois este pode
  // ser alterado no cadastro de aluno, #TODO criar migracao para remover PK de tal campo ?
  protected $_primaryKey = array(
    'aluno' #, 'alunoInep'
  );

  // fixup para find funcionar em tabelas cujo PK no se chama id
  protected function _getFindStatment($pkey)
  {
    if (! is_array($pkey))
      $pkey = array('cod_aluno' => $pkey);

    return parent::_getFindStatment($pkey);
  }
}